/*
 *  =============================================================
 *  DemoLoops.java: Demo features of simple looping structures..
 *
 *  Written By: Mark Austin                           August 2004
 *  =============================================================
 */

package basics;

public class DemoLoops {

   // Constructor method.

   public DemoLoops() {};

   // Define NoColums to be a "constant" .... (see use below)

   public final static int NoColumns = 6;

   // main method : this is where the program execution begins.

   public static void main ( String [] args ) {
       int i, j;

       // [a] Print components of a simple "while" loop.....

       System.out.println( "Demo 1: Simple \"while\" loop");
       System.out.println( "===========================================");

       i = 0;
       while ( i <= 4 ) {
           System.out.println( "Loop: " + (i+1) );
           System.out.println( "  i = " + i + " :(i <= 4) is " + (i<=4) );

           i = i + 1;
       }

       System.out.println( "End of Loop: ");
       System.out.println( "  i = " + i + " :(i <= 4) is " + (i<=4) );
       System.out.println( "===========================================");

       // [b] Print components of a simple "for" loop.....

       System.out.println( "\nDemo 2: Simple \"for\" loop");
       System.out.println( "===========================================");
       System.out.println( "Start Loop: ");

       for ( i = 0; i <= 4; i = i + 1) {
           System.out.println( "Loop: " + (i+1) );
           System.out.println( "  i = " + i +
                             " :(i <= 4) is " + (i<=4) );
       }

       System.out.println( "End of Loop: ");
       System.out.println( "  i = " + i + " :(i <= 4) is " + (i<=4) );
       System.out.println( "===========================================");

       // [c] Print components of a loop containing two variables
       //     that are incremented in value.

       System.out.println( "\nDemo 3: A \"for\" loop with two variables");
       System.out.println( "===========================================");
       System.out.println( "Start Loop: ");

       for ( i = 0, j = 0; i <= 4 && j < 7; i=i+1, j=j+2) {
           System.out.println( "Loop: " + (i+1) );
           System.out.print( "  i = " + i + " j = " + j);
           System.out.println( " :(i <= 4) is " + (i<=4) +
                               " :(j < 7) is " + (j<7) );
       }

       System.out.println( "End of Loop: ");
       System.out.print( "  i = " + i + " j = " + j);
       System.out.println( " :(i <= 4) is " + (i<=4) + " :(j < 7) is " + (j<7) );
       System.out.println( "===========================================");

       // [d] Print components of a nested for loop....

       System.out.println( "\nDemo 4: Nested \"for\" loop ");
       System.out.println( "===========================================");
       System.out.println( "Start Loop: ");

       int iLoopNo = 1;
       for ( i = 0; i <= 4; i = i + 1 ) {
          for ( j = 0; j <= 6; j = j + 3 ) {

             System.out.print( "Loop No: " + iLoopNo );
             System.out.println( "  i = " + i + " j = " + j);

             iLoopNo = iLoopNo + 1;
          }
       }

       System.out.println( "End of Loop: ");
       System.out.println( "===========================================");
   }
}
