/** 
  *  ===============================================================
  *  TestVector2D.java: Exercise methods in Vector2D class ...
  * 
  *  Written by: Mark Austin                             April, 2019
  *  ===============================================================
  */

package geometry;

import java.lang.Math;

public class TestVector2D {
   public static void main ( String args[] ) {

      // Create two test vectors ...

      Vector2D vA = new Vector2D( 1.0, 2.0 );
      Vector2D vB = new Vector2D( 2.0, 2.0 );

      // Print test vectors ...
      
      System.out.println( "Vector2D vA = " + vA.toString() );
      System.out.println( "Vector2D vB = " + vB.toString() );

      // Compute and print sum and difference of test vectors ...

      System.out.println( "Vector2D vA + vB = " + vA.add(vB).toString() );
      System.out.println( "Vector2D vA - vB = " + vA.sub(vB).toString() );

      // Compute and print normalized test vectors ...

      System.out.println( "vA.normalize() = " + vA.normalize().toString() );
      System.out.println( "vB.normalize() = " + vB.normalize().toString() );

      // Verify that dot products vA.vB and vB.vA are equal ...

      System.out.println( "Dot product vA.vB = " + vA.dotProduct(vB) );
      System.out.println( "Dot product vB.vA = " + vB.dotProduct(vA) );
   }
}
