/*
 * =========================================================================
 * TestConsumer03.java: ....
 * =========================================================================
 */

package lambda;

import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;

public class TestConsumer03 {

   public static void main(String[] args) {
      List<Student> students = Arrays.asList( new Student("John", 3.0), new Student("Mark", 4.0) );

      // Part 01: Print name of each student ...

      System.out.printf("--- Part 01: print name of each student ...\n");

      acceptAllEmployee(students, e -> System.out.printf("Student: %s ...\n", e.name) );

      // Part 02: Multiply student gpa's by 1.5 ...

      System.out.printf("--- Part 02: Multiply student gpa's by 1.5 ...\n");

      acceptAllEmployee(students, e -> { e.gpa *= 1.5; });

      // Part 03: Print details of each student ....

      System.out.printf("--- Part 03: print details of each student ... \n");

      acceptAllEmployee(students, e -> System.out.printf("Student: %s, gpa = %f ...\n", e.name, e.gpa ));
   }

   public static void acceptAllEmployee(List<Student> student, Consumer<Student> printer) {
      for (Student e : student) {
         printer.accept(e);
      }
   }
}
