package lambda;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Function;
import java.util.function.Predicate;

public class TestPredicate03 {
   public static void main(String[] args) {

      System.out.printf("--- TestPredicate03.main() ...\n");

      List<Student> employees = Arrays.asList( new Student(1, 3.1, "John"),
                                               new Student(2, 3.3, "Jane"),
                                               new Student(3, 4.0, "Jack") );

      // Print student employee details ...

      System.out.println( employees );

      // Part 01: Find students with gpa > threshold ....

      System.out.printf("--- Part 01: Use custom predicate to find students with gpa > threshold ...\n");
      System.out.println( findStudents( employees, createCustomPredicateWith( 3.2 ) ) );

      // Part 02: Use function definition to find students gpa > threshold ....

      Function<Double, Predicate<Student>> customFunction = threshold -> (e -> e.gpa > threshold);

      System.out.printf("--- Part 02: Use function definition to students with gpa > threshold ...\n");
      System.out.println( findStudents( employees, customFunction.apply( 3.5 )) );
   }

   private static Predicate<Student> createCustomPredicateWith(double threshold) {
      return e -> e.gpa > threshold;
   }

   // Find student who satisfy the predicate condition ...

   private static List<Student> findStudents(List<Student> employees, Predicate<Student> condition) {
      List<Student> result = new ArrayList<>();

      for (Student e : employees) {
         if (condition.test(e) == true ) {
            result.add(e);
         }
      }

      return result;
   }

}
