/**
 * ==========================================================
 * TestPerceptron.java: Test simple perceptron model.
 *
 * Written by: Mark Austin
 * ==========================================================
 */

package neural;

public class TestPerceptron {
    public static void main(String[] args) {

        System.out.printf("TestPerceptron ...\n" );
        System.out.printf("=================================== ...\n" );

        // Step 1: Initialize and print perceptron model ....

        System.out.printf("Step 1: Initialize perceptron ...\n" );

        Perceptron p = new Perceptron();
        p.setThreshold(0.05);
        p.setLearningRate(0.1);
        p.setEpochs(50);

        System.out.println( p.toString() );

        // Step 2: Create input/output for AND model ....

        System.out.printf("Step 2: Create input/output for AND model ...\n" );

        double inputs[][] = {{0,0},{0,1},{1,0},{1,1}};
        int     outputs[] = {0,0,0,1};

        // Step 3: Train perceptron model ....

        System.out.printf("Step 3: Train model ...\n" );

        p.trainModel( inputs, outputs );

        System.out.println( p.toString() );

        // Step 4: Exercise trained model....

        System.out.printf("Step 4: Exercise trained model ...\n" );

        System.out.println( p.Output(new double[]{0,0}) );
        System.out.println( p.Output(new double[]{1,0}) );
        System.out.println( p.Output(new double[]{0,1}) );
        System.out.println( p.Output(new double[]{1,1}) );

        System.out.printf("=================================== ...\n" );
        System.out.printf("Finished !! ...\n" );
    }
}
