/* 
 *  =================================================================
 *  ColoredCircle(): Implementation of the ColoredCircle class where
 *                   data and circle properties can only be accessed
 *                   through an interface.
 * 
 *  Written By: Mark Austin                                April 2009
 *  =================================================================
 */

package objects;

import java.awt.Color;

public class ColoredCircle extends Circle {
    private Color color;

    // Constructor methods 

    public ColoredCircle() {
        super();
        this.color = Color.blue;
    }

    public ColoredCircle( double dX, double dY, double dRadius, Color color ) {
        super();

        this.dX = dX;
        this.dY = dY;
        this.dRadius = dRadius;
        this.color   = color;
    }

    // Set and retrieve colors ....

    public void setColor( Color color ) {
       this.color = color;
    }

    public String getColors() {
       return "Color (r,g,b) = (" + color.getRed() + "," + color.getGreen() + "," + color.getBlue() + ")";
    }

    // ===============================================
    // Exercise methods in class ColoredCircle()......
    // ===============================================

    public static void main( String [] args ) {

       System.out.println("Exercise methods in class ColoredCircle");
       System.out.println("=======================================");

       // Create, initialize, and print circle "cA" ...

       ColoredCircle cA = new ColoredCircle( 1.0, 2.0, 3.0, Color.blue );

       System.out.println( "Circle cA:" + cA.toString() );
       System.out.println( cA.getColors() );

       // Create, initialize, and print circle "cB" ...

       ColoredCircle cB = new ColoredCircle( -1.0, -2.0, 3.0, Color.orange );
       System.out.println( "Circle cB:" + cB.toString() );
       System.out.println( cB.getColors() );
    }
}
