/*
 * =====================================================================
 * RegularExpressions02.java: ....
 * =====================================================================
 */

package regex;

import java.util.regex.Pattern;
import java.util.Scanner;

public class RegularExpressions02 {
  public static void main(String args[]) {

    System.out.printf("Example01: Split string with compound pattern ...\n");

    String input01 = "I will not compromise. I will not " +
                     "cooperate. There will be no concession, no conciliation, no " +
                     "finding the middle ground, and no give and take.";

    String pattern01 = "compromise|cooperate|concession|" + "conciliation|(finding the middle ground)|(give and take)";

    Pattern p01 = Pattern.compile(pattern01);
    String tokens[] = p01.split(input01);

    System.out.println("Pattern: " + pattern01 + "\n");
    System.out.println("Input:" + input01 + "\n");
    System.out.println("Array of Tokens:");
    for (int i = 0; i < tokens.length; i++) {
       System.out.printf("-- Token %d: %s ...\n", i, tokens[i]);
    }

    System.out.printf("Example02: Parse dimension vector ...\n");
    String velocityDimension = "qudt:M0L1T-1t0";
    String pattern02 = "L|M|T|t";

    System.out.printf("Input: %s ...\n", velocityDimension );
    System.out.printf("Pattern: %s ...\n", pattern02 );

    Pattern p02 = Pattern.compile(pattern02);
    String tokens02[] = p02.split(velocityDimension);

    System.out.println("Array of Tokens:");
    for (int i = 0; i < tokens02.length; i++) {
       System.out.printf("-- Token %d: %s ...\n", i, tokens02[i]);
    }

    System.out.printf("Example03: Use scanner to extract exponent coefficients ...\n");
    System.out.printf("Input: %s ...\n", velocityDimension );

    // Find length exponent ...

    Scanner dimenInput = new Scanner(velocityDimension);

    String pattern03 = "L(\\d+)";
    Pattern p03 = Pattern.compile(pattern03);

    String result = dimenInput.findInLine( p03 ); 
    System.out.printf("Result: %s ...\n", result );

    Scanner input03 = new Scanner( result.substring(1) );
    if ( input03.hasNextInt() == true) {
       int i = input03.nextInt();
       System.out.printf("Length exponent: %d ...\n", i );
    } else {
       System.out.printf("Length exponent: Error !! ...\n");
    } 

    // Find mass exponent ...

    dimenInput = new Scanner(velocityDimension);

    Pattern p04 = Pattern.compile("M(\\d+)");

    String result02 = dimenInput.findInLine( p04 ); 
    System.out.printf("Result: %s ...\n", result02 );

    Scanner input04 = new Scanner( result02.substring(1) );
    if ( input04.hasNextInt() == true) {
       int i = input04.nextInt();
       System.out.printf("Mass exponent: %d ...\n", i );
    } else {
       System.out.printf("Mass exponent: Error !! ...\n");
    } 

    // Time exponent ...

    dimenInput = new Scanner(velocityDimension);

    Pattern p05 = Pattern.compile("T[-+]?(\\d+)");

    String result03 = dimenInput.findInLine( p05 ); 
    System.out.printf("Result: %s ...\n", result03 );

    Scanner input05 = new Scanner( result03.substring(1) );
    if ( input05.hasNextInt() == true) {
       int i = input05.nextInt();
       System.out.printf("Time exponent: %d ...\n", i );
    } else {
       System.out.printf("Time exponent: Error !! ...\n");
    } 



  }
}
